/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.musicsearcher.providers;

import java.util.List;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.Future;
import java.util.concurrent.FutureTask;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;
import moe.nekojimi.musicsearcher.Result;

/**
 *
 * @author jim
 */
public abstract class Searcher 
{
    private final String name;
    private final ForkJoinPool executor;

    public Searcher(String name) 
    {
        this.name = name;
        this.executor = new ForkJoinPool();
    }
    
    public List<Result> searchAndWait(String query) throws InterruptedException, ExecutionException
    {
        try 
        {
            return searchAndWait(query, Long.MAX_VALUE, TimeUnit.DAYS);
        } catch (TimeoutException ex) 
        {
            throw new RuntimeException("This should never happen!",ex);
        }
    }
    
    public List<Result> searchAndWait(String query, long limit, TimeUnit unit) throws InterruptedException, ExecutionException, TimeoutException
    {
        return search(query).get(limit, unit);
    }
    
    public Future<List<Result>> search(String query)
    {
        FutureTask<List<Result>> task = new FutureTask<>(() -> 
        {
            return doSearch(query);
        });
        executor.execute(task);
        return task;
    }

    protected abstract List<Result> doSearch(String query);
}
